<template>

    <div class="container" v-if="article"> 
                
        <h1>{{ article.titre }}</h1>
    
        <div class="flex">
            <p> Date: {{ article.date_article }}</p>
            <p> Nombre de vue : {{ article.vue }}</p>
    
            <!-- afficher la categorie d'article -->
            <div > 
                <RouterLink :to="'/article/categorie/' + article.id_categorie" active-class="active"> 
                <a class="waves-effect waves-light btn" v-if="article.id_categorie == 1 ">
                    Categorie: Plat
                </a>
                </RouterLink>
    
                <RouterLink :to="'/article/categorie/' + article.id_categorie" active-class="active"> 
                <a class="waves-effect waves-light btn" v-if="article.id_categorie == 2 ">
                    Categorie: Dessert
                </a>
                </RouterLink>
    
                <RouterLink :to="'/article/categorie/' + article.id_categorie" active-class="active"> 
                <a class="waves-effect waves-light btn" v-if="article.id_categorie == 3 ">
                    Categorie: Produit
                </a>
                </RouterLink>
    
                <RouterLink :to="'/article/categorie/' + article.id_categorie" active-class="active"> 
                    <a class="waves-effect waves-light btn" v-if="article.id_categorie == 4 ">
                        Categorie: Magasin
                    </a>
                </RouterLink>
    
                <RouterLink :to="'/article/categorie/' + article.id_categorie" active-class="active"> 
                    <a class="waves-effect waves-light btn" v-if="article.id_categorie == 5 ">
                        Categorie: Restaurant
                    </a>
                </RouterLink>
            </div>        
        </div>
    
        <div>
            <img :src="article.photo" alt="">   
            <p>{{ article.text  }}</p>
        </div>
    
    
        <FormArticle v-if="editing" :initialArticle="article" @submit="handleSubmit($event)"></FormArticle>
        <button v-if="auth.user" class="btn btn-danger" @click="editing = !editing"> Modifier </button>
        <!-- <button class="btn btn-danger" @click="editing = !editing"> Modifier </button> -->
        <button v-if="auth.user" class="btn btn-danger" @click="handleDelete() "> Supprimer </button>
    
        <CommentaireList></CommentaireList>
        
    </div>
    
    </template>
    
    <script setup lang="ts">
    
    import type { Article } from '@/entities';
    import router from '@/router';
    import { deleteArticles, fetchOneArticles, updateArticles } from '@/service/article-service';
    import { ref, watch } from 'vue';
    import { useRoute } from 'vue-router';
    import CommentaireList from '@/components/CommentaireList.vue';
    import { useAuth } from '@/stores/auth';
    import FormArticle from '@/components/FormArticle.vue';
    
    
    const route = useRoute();
    const article = ref<Article>();
    const editing = ref(false);
    const auth = useAuth();
    
    
    watch(() => route.params.id, async () =>{
        article.value = await fetchOneArticles(route.params.id);
    }, {immediate:true})
    
    async function  handleDelete() {
        await deleteArticles(article.value?.id);
        router.push('/');
    }
    
    async function handleSubmit(updateA:Article) {
        await updateArticles(updateA);
        article.value = updateA;
        editing.value = false;
    }
    
    
    
    
    
    
    </script>
    
    <style scoped> 
    
    h1{
        font-size: 3rem;
    }
    
    img{
        width: 50%;
    }
    
    .flex{
        display: flex;
        gap: 30px;
    }
    
    button{
        margin-right: 20px;
    }
    
    </style>